datablock TSShapeConstructor(RCHeliDts)
{
	baseShape  = "./RC_Heli.dts";
	sequence0  = "./RC_H_root.dsq root";
   sequence1 = "./RC_H_root.dsq death1";
};

datablock PlayerData(RCHeliArmor : PlayerStandardArmor)
{
	shapefile = "./RC_Heli.dts";
	aircontrol=3;
	minlookangle=-0.5;
	maxlookangle=0.5;
	renderFirstPerson=0;
	maxForwardSpeed=0;
	maxSideSpeed=0;
	maxBackwardSpeed=0;
	maxForwardCrouchSpeed=0;
	maxSideCrouchSpeed=0;
	maxBackwardCrouchSpeed=0;
	maxUnderWaterBackwardSpeed=0;
	maxUnderWaterForwardSpeed=0;
	maxUnderWaterSideSpeed=0;
	maxJumpSpeed=0;
	jetEmitter="";
	JetGroundDistance=5;
	cameraVerticalOffset="0.25";
	cameraTilt="0.7";
	cameraMaxDist=6;
	cameraMinDist=0;
	canJet=1;
	JetEnergyDrain=0;
	maxEnergy=100;
	mass=30;
	rechargeRate=0;
	pickupRadius=0;
	runForce=6000;
	jumpForce=0;
	ridable=0;
	canRide=0;
	uiname="";
	boundingBox="4.5 4.5 4.5";
	crouchBoundingBox="4.5 4.5 4.5";
};
datablock AudioProfile(rcHeliDeploySound)
{
   filename    = "./explosion.wav";
   description = AudioClosest3d;
   preload = true;
};
function RCHeli_Spawn(%p,%c,%a)
{
   %b=new AIPlayer()
   {
      datablock=RCHeliArmor;
      position=%p;
      isRCBot=1;
      scale="1 1 1";
   };
   lolApp(%b,%c);
   MissionCleanup.add(%b);
   if(!isObject(RCBotGroup))
      new SimGroup(RCBotGroup){};
   RCBotGroup.add(%b);
   return %b;
}
function lolApp(%b,%c)
{
   %b.setNodeColor("Body",%c);
}
function AIPlayer::doOwnerCheck(%this)
{
   cancel(%this.ownerCheck);
   %o=%this.owner;
   if(!isObject(%o) || %o.getDamagePercent() == 1)
   {
      %this.handleDeath();
      %this.delete();
      return;
   }
   if(%this.getDamagePercent() == 1)
   {
      %this.handleDeath();
      %this.delete();
      return;
   }
   if(%this.owner.Client.getControlObject() != %this && %this.owner.Client.getControlObject() != %this.owner.Client.camera && %this.getDamagePercent() != 1)
      %this.owner.Client.setControlObject(%this);
   %this.ownerCheck=%this.schedule(100,doOwnerCheck);
}
function servercmdclearRCbots(%c)
{
   if(!%c.isAdmin)
      return;
   if(!isObject(RCBotGroup))
      return;
   if(RCBotGroup.getCount() == 0)
      return;
   messageAll('MsgClearBricks','\c3%1\c0 cleared RC bots (%2)',%c.name,RCBotGroup.getCount());
   RCCar_Cleanup();
}
function RCCar_Cleanup(%i)
{
   if(!isObject(RCBotGroup))
      return;
   if(RCBotGroup.getCount() > 0)
   {
      RCBotGroup.getObject(0).kill();
      RCBotGroup.remove(RCBotGroup.getObject(0));
   }
   else
      return;
   if(%i>=24)
      return schedule(16,0,RCCar_Cleanup);
	return RCCar_Cleanup(%i++);
}
datablock ProjectileData(rcBotProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Default;
   radiusDamageType    = $DamageType::Default;
   uiName = "";
};
datablock ParticleData(rcBotParticle) {
   dragCoefficient = "10";
   windCoefficient = "0";
   gravityCoefficient = "0";
   inheritedVelFactor = "1";
   constantAcceleration = "2";
   lifetimeMS = "300";
   lifetimeVarianceMS = "100";
   spinSpeed = "0";
   spinRandomMin = "0";
   spinRandomMax = "0";
   useInvAlpha = "0";
   animateTexture = "0";
   framesPerSec = "1";
   textureName = "./bolt";
   animTexName[0] = "./bolt";
   colors[0] = "1.000000 1.000000 0.466667 1.000000";
   colors[1] = "1.000000 1.000000 0.000000 1.000000";
   colors[2] = "1.000000 0.000000 0.000000 0.000000";
   colors[3] = "1.000000 1.000000 1.000000 1.000000";
   sizes[0] = "0.497467";
   sizes[1] = "0.247207";
   sizes[2] = "0";
   sizes[3] = "1";
   times[0] = "0";
   times[1] = "0.498039";
   times[2] = "1";
   times[3] = "2";
};
datablock ParticleEmitterData(rcBotEmitter) {
   className = "ParticleEmitterData";
   ejectionPeriodMS = "1";
   periodVarianceMS = "0";
   ejectionVelocity = "12";
   velocityVariance = "0";
   ejectionOffset = "0";
   thetaMin = "0";
   thetaMax = "60";
   phiReferenceVel = "0";
   phiVariance = "360";
   overrideAdvance = "1";
   orientParticles = "1";
   orientOnVelocity = "1";
   particles = "rcBotParticle";
   lifetimeMS = "0";
   lifetimeVarianceMS = "0";
   useEmitterSizes = "0";
   useEmitterColors = "0";
   uiName = "";
   doFalloff = "1";
   doDetail = "1";
};
datablock itemData(RCHeliItem : PrintGun)
{
   uiName = "Remote Control Helicopter";
   image = RCHeliImage;
   docolorshift=1;
   colorshiftColor="1 0 1 1";
};
datablock shapeBaseImageData(RCHeliImage : PrintGunImage)
{
   rotation=eulerToMatrix("0 180 0");
   offset="0 0 0";
   docolorshift=1;
   showBricks=0;
   colorshiftColor="1 0 1 1";
   item = RCBotItem;
   projectile=rcBotProjectile;
   stateEmitter[2] = "rcBotEmitter";
   stateEmitterTime[2] = 0.5;
};
function RCHeliImage::onFire(%this,%obj,%slot)
{
   parent::onFire(%this,%obj,%slot);
   if(!isObject(%c=%obj.client))
      return;
   if(isObject(%obj.rcBot))
   {
      %c.centerprint("\c5You already have an RC Helicopter",3);
      return;
   }
   if(%c.getControlObject() != %obj)
   {
      %c.centerprint("\c5You need the right body to do this!",3);
      return;
   }
   %start = %obj.getPosition();
   %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType |$TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
   %vec   = %obj.getForwardVector();
   %end   = vectorAdd(%start,vectorScale(%vec,4));
   %ray = containerRaycast(%start,%end,%targets,%obj);
   %col = firstWord(%ray);
   if(isObject(%col))
   {
      %c.centerprint("\c5You can't spawn a helicopter there!",3);
      return;
   }
   %p=vectorAdd(vectorScale(%obj.getForwardVector(),2.5),%obj.getPosition());
   %obj.rcBot=RCHeli_Spawn(%p,%c.chestColor,%obj);
   %b=%obj.rcBot;
   %b.setTransform(%b.getPosition() SPC getWords(%obj.getTransform(),3,6));
   %b.setVelocity(vectorAdd(vectorScale(%obj.getEyeVector(),10),%obj.getVelocity()));
   %b.ownerName=%c.name;
   %b.ownerBL_ID=%c.bl_id;
   %b.ownerClient=%c;
   %b.owner=%obj;
   serverplay3d(rcbotDeploySound,%b.getTransform());
   %b.SpawnExplosion("SpawnProjectile",%b.scale);
   %b.doOwnerCheck();
   %c.setControlObject(%b);
   %c.centerprint("\c5Use your \c2Light\c5 to leave this mode",5);
}
if(isPackage(rcBot))
   deactivatepackage(rcBot);
package rcBot
{
   function servercmdLight(%c)
   {
      if(!isObject(%p=%c.player))
      {
         Parent::ServercmdLight(%c);
         return;
      }
      if(!isObject(%b=%c.player.rcBot))
      {
         Parent::ServercmdLight(%c);
         return;
      }
      %c.setControlObject(%p);
      serverplay3d(rcbotDeploySound,%b.getTransform());
      %p.rcBot.SpawnExplosion("SpawnProjectile",%p.rcBot.scale);
      %p.rcBot.delete();
   }
   function AIPlayer::handleDeath(%this)
   {
      if(isObject(%this.owner)&&%this.owner.client.getControlObject()!=%this.owner)
      {
         %this.owner.client.setControlObject(%this.owner);
         serverplay3d(rcbotDeploySound,%this.getTransform());
         %this.SpawnExplosion("SpawnProjectile",%this.scale);
      }
   }
   function servercmdUseSprayCan(%c,%i)
   {
      parent::servercmdUseSprayCan(%c,%i);
      if(!isObject(%c.player))
         return;
      if(!isObject(%b=%c.player.rcBot))
         return;
      if(getSimTime() - %c.player.rcBot.lastRecolor < 50)
      {
         %c.centerprint("\c5Failure to change bot's color; Too Fast",3);
         return;
      }
      %c.player.rcBot.lastRecolor=getSimTime();
      lolApp(%b,getWords(getColorIDTable(%i),0,2)@" 1");
   }
};
activatepackage(rcBot);